<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOptionSelected ArrayType
 * @subpackage Arrays
 */
class ArrayOfOptionSelected extends AbstractStructArrayBase
{
    /**
     * The OptionSelected
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\OptionSelected[]
     */
    public $OptionSelected;
    /**
     * Constructor method for ArrayOfOptionSelected
     * @uses ArrayOfOptionSelected::setOptionSelected()
     * @param \StructType\OptionSelected[] $optionSelected
     */
    public function __construct(array $optionSelected = array())
    {
        $this
            ->setOptionSelected($optionSelected);
    }
    /**
     * Get OptionSelected value
     * @return \StructType\OptionSelected[]|null
     */
    public function getOptionSelected()
    {
        return $this->OptionSelected;
    }
    /**
     * This method is responsible for validating the values passed to the setOptionSelected method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOptionSelected method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOptionSelectedForArrayConstraintsFromSetOptionSelected(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOptionSelectedOptionSelectedItem) {
            // validation for constraint: itemType
            if (!$arrayOfOptionSelectedOptionSelectedItem instanceof \StructType\OptionSelected) {
                $invalidValues[] = is_object($arrayOfOptionSelectedOptionSelectedItem) ? get_class($arrayOfOptionSelectedOptionSelectedItem) : sprintf('%s(%s)', gettype($arrayOfOptionSelectedOptionSelectedItem), var_export($arrayOfOptionSelectedOptionSelectedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OptionSelected property can only contain items of type \StructType\OptionSelected, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OptionSelected value
     * @throws \InvalidArgumentException
     * @param \StructType\OptionSelected[] $optionSelected
     * @return \ArrayType\ArrayOfOptionSelected
     */
    public function setOptionSelected(array $optionSelected = array())
    {
        // validation for constraint: array
        if ('' !== ($optionSelectedArrayErrorMessage = self::validateOptionSelectedForArrayConstraintsFromSetOptionSelected($optionSelected))) {
            throw new \InvalidArgumentException($optionSelectedArrayErrorMessage, __LINE__);
        }
        $this->OptionSelected = $optionSelected;
        return $this;
    }
    /**
     * Add item to OptionSelected value
     * @throws \InvalidArgumentException
     * @param \StructType\OptionSelected $item
     * @return \ArrayType\ArrayOfOptionSelected
     */
    public function addToOptionSelected(\StructType\OptionSelected $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OptionSelected) {
            throw new \InvalidArgumentException(sprintf('The OptionSelected property can only contain items of type \StructType\OptionSelected, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OptionSelected[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OptionSelected|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OptionSelected|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OptionSelected|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OptionSelected|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OptionSelected|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OptionSelected
     */
    public function getAttributeName()
    {
        return 'OptionSelected';
    }
}
