<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EstablishmentUpdatedOn StructType
 * @subpackage Structs
 */
class EstablishmentUpdatedOn extends BaseUpdatedOn
{
    /**
     * The Services
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Services;
    /**
     * The Products
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfProductUpdatedOn
     */
    public $Products;
    /**
     * Constructor method for EstablishmentUpdatedOn
     * @uses EstablishmentUpdatedOn::setServices()
     * @uses EstablishmentUpdatedOn::setProducts()
     * @param string $services
     * @param \ArrayType\ArrayOfProductUpdatedOn $products
     */
    public function __construct($services = null, \ArrayType\ArrayOfProductUpdatedOn $products = null)
    {
        $this
            ->setServices($services)
            ->setProducts($products);
    }
    /**
     * Get Services value
     * @return string
     */
    public function getServices()
    {
        return $this->Services;
    }
    /**
     * Set Services value
     * @param string $services
     * @return \StructType\EstablishmentUpdatedOn
     */
    public function setServices($services = null)
    {
        // validation for constraint: string
        if (!is_null($services) && !is_string($services)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($services, true), gettype($services)), __LINE__);
        }
        $this->Services = $services;
        return $this;
    }
    /**
     * Get Products value
     * @return \ArrayType\ArrayOfProductUpdatedOn|null
     */
    public function getProducts()
    {
        return $this->Products;
    }
    /**
     * Set Products value
     * @param \ArrayType\ArrayOfProductUpdatedOn $products
     * @return \StructType\EstablishmentUpdatedOn
     */
    public function setProducts(\ArrayType\ArrayOfProductUpdatedOn $products = null)
    {
        $this->Products = $products;
        return $this;
    }
}
